Bug 1420277 - python-virtualenv: preinstalled packages downloaded from PyPI by default
Summary: python-virtualenv: preinstalled packages downloaded from PyPI by default
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: python-virtualenv
Version: 28
Hardware: Unspecified
OS: Unspecified
unspecified
medium
Target Milestone: ---
Assignee: Steve Milner
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-02-08 10:39 UTC by Tomas Hoger
Modified: 2019-05-28 22:13 UTC (History)
6 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
: 1469594 (view as bug list)
Environment:
Last Closed: 2019-05-28 22:13:43 UTC
Type: Bug


Attachments (Terms of Use)

Description Tomas Hoger 2017-02-08 10:39:35 UTC
Description of problem:

When creating new virtualenv, pip, setuptool and wheel are installed by default unless --no-{pip,setuptool,wheel} is used.  python-virtualenv packages contain those additional packages.

In the past, the default was to install those bundled packages and require user to manually update them later if needed (e.g. using: pip install -U pip).  However, that default changed with version 14.0.1:

https://virtualenv.pypa.io/en/stable/changes/#id11

  14.0.1 (2016-01-21)
    ...
    Fix the default of --(no-)download to default to downloading.

https://github.com/pypa/virtualenv/commit/3d7361ff2e31472cb69d00150fbdf5a3c9af2a0d

Therefore, as of Fedora 24, there's code installed from remote PyPI repos when user creates new virtualenv with default options and without running pip manually.  This default should be reviewed if it's appropriate for Fedora.

Comment 2 Fedora End Of Life 2017-02-28 11:12:45 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 26 development cycle.
Changing version to '26'.

Comment 3 Fedora End Of Life 2018-02-20 15:38:12 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 28 development cycle.
Changing version to '28'.

Comment 4 Miro Hrončok 2018-08-23 18:33:44 UTC
> This default should be reviewed if it's appropriate for Fedora.

Based on what? Legal? Or packaging guidelines, or...?

Comment 5 Tomas Hoger 2018-08-23 19:38:48 UTC
Based on the fact that venv creation now automatically downloads and runs code from outside Fedora without user request and possibly knowledge.

Comment 6 Miro Hrončok 2018-08-23 19:47:07 UTC
I see why this might be potentially shocking or "insecure", but it's how virtualenv works. What do you think would be the best course of action? Diverging from upstream?

Also, virtualenv is a tool to create environments where you would immediately jump into downloading and running code from outside Fedora. I don't think this is severe problem.

Comment 7 Tomas Hoger 2018-08-23 20:24:20 UTC
I wasn't trying to force any particular way, or present this as shocking, but to open a discussion related to the change in the upstream behaviour.  venv bundles pip, setuptools, and wheel, so it seems quite reasonable to install that and update when needed upon user request.  That's even what happened before 14.0.1.

I do not know if installing from the public PyPi in the only real use case.  My understanding is you can be installing only form some internal locations too.  Hence the concern about the default.

And yes, it's not severe problem, as there's --no-download option to override the default.

Comment 9 Ben Cotton 2019-05-02 21:02:18 UTC
This message is a reminder that Fedora 28 is nearing its end of life.
On 2019-May-28 Fedora will stop maintaining and issuing updates for
Fedora 28. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora 'version' of '28'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 28 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 10 Ben Cotton 2019-05-28 22:13:43 UTC
Fedora 28 changed to end-of-life (EOL) status on 2019-05-28. Fedora 28 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.